; Scheme extensions for SCOP


; scop-get-message-se

(define scop-get-message-se (lambda (sock . rpc-flag)
  (let ((message-string (if (null? rpc-flag)
                          (scop-get-message sock)
                          (scop-get-message sock (car rpc-flag)))))
    (let* ((port (open-input-string message-string))
           (message (read port)))
      (close-input-port port)
      message))))


; scop-rpc-se

(define scop-rpc-se (lambda (sock endpoint args)
  (let ((out-port (open-output-string)))
    (write args out-port)
    (let ((args-string (get-output-string out-port)))
      (close-output-port out-port)
      (let* ((reply-string (scop-rpc sock endpoint args-string))
             (in-port (open-input-string reply-string))
             (reply (read in-port)))
        (close-input-port in-port)
        reply)))))


; scop-send-message-se

(define scop-send-message-se (lambda (sock endpoint message . verify)
  (let ((port (open-output-string)))
    (write message port)
    (let ((message-string (get-output-string port)))
      (close-output-port port)
      (if (null? verify)
        (scop-send-message sock endpoint message-string)
        (scop-send-message sock endpoint message-string (car verify)))))))


; scop-send-reply-se

(define scop-send-reply-se (lambda (sock reply)
  (let ((port (open-output-string)))
    (write reply port)
    (let ((reply-string (get-output-string port)))
      (close-output-port port)
      (scop-send-reply sock reply-string)))))

