; scop.scm

(define scop-clear (lambda (sock endpoint)
  (c_scop_clear sock endpoint)
  #unspecified))

(define scop-close (lambda (sock)
  (c_close sock)))

(define scop-emit (lambda (sock message . verify0)
  (let ((verify (if (pair? verify0)
                  (car verify0)
                  0)))
    (c_scop_emit sock message verify))))

;(define scop-free (lambda (ptr) ; not needed
;  (c_free ptr)))

(define scop-get-message (lambda (sock . rpc-flag)
  (if (null? rpc-flag)
    (c_scop_get_message sock (make-null-intp))
    (c_scop_get_message sock (make-null-intp)) ; ZZZ use address of integer rpc-flag instead of 0
    )))

(define scop-listen (lambda (sock interest . unique0)
  (let ((unique (if (pair? unique0)
                  (car unique0)
                  0)))
    (c_scop_listen sock interest unique)
    #unspecified)))

(define scop-open (lambda (remote-hostname name . unique0)
  (let ((unique (if (pair? unique0)
                  (car unique0)
                  0)))
    (c_scop_open remote-hostname name unique))))

(define scop-query (lambda (sock endpoint)
  (c_scop_query sock endpoint)))

(define scop-reconfigure (lambda (sock)
  (c_scop_reconfigure sock)
  #unspecified))

(define scop-rpc (lambda (sock remote-hostname args)
  (c_scop_rpc sock remote-hostname args)))

(define scop-send-message (lambda (sock endpoint message . verify0)
  (let ((verify (if (pair? verify0)
                  (car verify0)
                  0)))
    (c_scop_send_message sock endpoint message verify))))

(define scop-send-reply (lambda (sock reply)
  (c_scop_send_reply sock reply)))

(define scop-set-log (lambda (sock log-level)
  (c_scop_set_log sock log-level)
  #unspecified))

(define scop-set-source-hint (lambda (sock endpoint)
  (c_scop_set_source_hint sock endpoint)
  #unspecified))

(define scop-terminate (lambda (sock)
  (c_scop_terminate sock)
  #unspecified))
